Program Multimeter;

Uses CRT, Dos;
Const  BufMax = 1023;     {Puffergre}
var BA : Integer;
    Buffer: Array [0..1023] of Char;
    LastIn, LastOut: Word;
    LnAvail, N, I: Integer;
    Ch : Char;
    Parameter: String;

procedure Oeffnen;
var  Wert : Byte;
begin
  Port[BA+3]:=$80; { }
  Port[BA+0]:=$60; { 1200 Baud }
  Port[BA+1]:=$00;
  Port[BA+3]:=$06; { 7-Bit, n-Parity, 2 Stopbits }
  Port[BA+4]:=$09; { DTR = 1, RTS = 0, out2 fr interrupt }
  wert := Port [BA];
  wert := Port [BA];
  Port[BA+1]:=$01;   { Freigabe: Interrupt fr Empfang }
end;

procedure Senden  ( Wert : Byte );
begin
  while (Port[BA] And 32) = 0 do; { Senderegister leer ? }
  Port[BA]:=Wert;
end;


{$F+}
procedure Int_Routine;Interrupt;
{$F-}
var Wert: Byte;
begin
     wert := port [BA];
     Buffer [LastIn AND BufMax]:= Chr (Wert);
     inc (LastIn);
     if Wert=13 then inc(LnAvail);
     Port[$20]:=$20;            { OCW2, Interrupt quittieren }
end;

function ChAvail: Boolean;
begin
  ChAvail := ((LastIn and BufMax) <> (LastOut and BufMax));
end;

function GetCh: Char;
begin
  GetCh := Buffer[LastOut AND BufMax];
  inc (LastOut);
end;

function GetLn: String;
var LineIn : String;
    Ch : Char;
begin
  LineIn := '';
  repeat
    Ch := GetCh;
    if Ch <> #13 then LineIn := LineIn + Ch;
  until Ch=#13;
  GetLn := LineIn;
  dec (LnAvail);
end;

procedure Init_IRQ4;
begin
  inline ($FA);
  SetIntVec($0C,@INT_ROUTINE);
  inline ($FB);
  Port[$21]:=Port[$21] AND $EF;      { OCW1: IRQ4 freigeben }
end;

procedure Init_IRQ3;
begin
  inline ($FA);
  SetIntVec($0B,@INT_ROUTINE);
  inline ($FB);
  Port[$21]:=Port[$21] AND $F7;      { OCW1: IRQ3 freigeben }
end;

procedure Stop_IRQ4;
begin
  Port[$21]:=Port[$21] OR $10;         { OCW1: IRQ4 sperren }
end;

procedure Stop_IRQ3;
begin
  Port[$21]:=Port[$21] OR $08;         { OCW1: IRQ3 sperren }
end;

begin
  LastIn:=0; LastOut:=0; Ch := ' ';
  LnAvail := 0;
  BA:=$02F8;          {COM2}
  Oeffnen;
  Init_IRQ3;          {fr COM2}
  ClrScr;
  repeat
    if (ChAvail) then write (getCh);         {Zeichenweise lesen}
{   if (LnAvail > 0) then writeln (getLn); } {Zeilenweise lesen}
  until KeyPressed;
  Stop_IRQ3;          {fr COM2}
end.
